#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;


int maxlog = 3;
ll mod = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    ll n, m, k;
    cin >> n >> m >> k;
    vector < vector < ll > > dp(n + 1, vector < ll > (maxlog + 1, 0));
    vector < vector < ll > > c(maxlog + 3, vector < ll > (maxlog + 3, 0));
    c[0][0] = 1;
    for (int i = 0; i <= maxlog; i++) {
        for (int j = 1; j <= maxlog; j++) {
            c[i][j] = (c[i][j - 1]);
            if(i > 0)
                c[i][j] += c[i - 1][j - 1];
            c[i][j] %= mod;
        }
    }

    for (int i = 0; i <= maxlog; i++) {
        dp[n][i] = 1;
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j <= maxlog; j++) {
            for (int x = 0; x <= j; x++) {
                dp[i][j] = (dp[i][j] + c[x][j] * dp[i + 1][j - x]) % mod;
            }
        }
    }
    ll ans = 0;
    int cnt = 0;
    int kc = k;
    int cntmax = 0;
    while (kc > 0) {
        if(kc % 2 == 1)
            cntmax = cnt;
        kc /= 2;
        cnt++;
    }
    cout << dp[0][cntmax + 1] << endl;

}
