#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;
ll mod = 1e9 + 7;
const int maxn = 5000;
int dp[maxn + 2][maxn + 2][2];
int pref[maxn + 2][maxn + 2];
int suf[maxn + 2][maxn + 2];

int main() {
    ios_base::sync_with_stdio(0);
    int n, k;
    cin >> n >> k;
    for (int i = 0; i <= n + 1; i++) {
        for (int j = 0; j <= n + 1; j++) {
            for (int z = 0; z < 2; z++) {
                dp[i][j][z] = 0;
                pref[i][j] = 0;
                suf[i][j] = 0;
            }
        }
    }
    dp[k][k][0] = 1;
    dp[k][k][1] = 1;
    if(n == k) {
        cout << 1;
        return 0;
    }

    for (int i = 1; i <= n; i++) {
        pref[k][i] = pref[k][i - 1];
        pref[k][i] = (pref[k][i] + dp[k][i][1]) % mod;
    }
    for (int j = n; j > 0; j--) {
        suf[k][j] = suf[k][j + 1];
        suf[k][j] = (suf[k][j] + dp[k][j][0]) % mod;
    }

   for (int i = k + 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            pref[i][j] = pref[i][j - 1];
            for (int c = 0; c < 2; c++) {
                if(i < j)
                    break;
                if(c == 0) {
                    dp[i][j][c] = pref[i - j][j - 1];
                }
                else {
                    dp[i][j][c] = suf[i - j][j + 1];
                    pref[i][j] = (pref[i][j] + dp[i][j][c]) % mod;
                }
            }
        }
        for (int j = n; j > 0; j--) {
            suf[i][j] = suf[i][j + 1];
            suf[i][j] = (suf[i][j] + dp[i][j][0]) % mod;
        }
    }
    ll ans = 0;
    for (int i = 0; i <= n; i++) {
        ans = (ans + dp[n][i][0] + dp[n][i][1]) % mod;
    }
    cout << ans << endl;
}

