#include <iostream>
#include <cmath>

using namespace std;

long long solve1(long long a, long long b, int k) {
    long long x, y;
    if((a + b) % 2 != 0)
        return -1;
    y = (a + b) / 2;
    x = b - y;
    if(y * y - x * x == k)
        return y;
    return -1;

}

long long solve2(long long a, long long b, int k) {
    long long x, y;
    if((a + b) % 2 != 0)
        return -1;
    y = (a + b) / 2;
    x = b - y;
    if(y * y - x * x == k && x > 0)
        return x;
    return -1;

}

int main() {

    long long k;
    cin >> k;

    if(k >= 0) {
        long long x = sqrtl(k);
        if(x * x == k) {
            cout << k;
            return 0;
        }
    }

    if(k > 0) {
        for (long long i = 1; i * i <= (k + 5); i++) {
            if(k % i != 0)
                continue;
            if(solve1(i, k / i, k) != -1) {
                cout << solve1(i, k / i, k);
                return 0;
            }
        }
        cout << "none";
        return 0;
    }
    long long kc = abs(k);
    for (long long i = 1; i * i <= (kc + 5); i++) {
        if(kc % i != 0)
            continue;
        if(solve2(i, kc / i, kc) != -1) {
            cout << solve2(i, kc / i, kc);
            return 0;
        }
    }
    cout << "none";

}
