#include <iostream>
#include <map>
#include <vector>
#include <set>
#define f first
#define s second


using namespace std;

vector<int> mv(int a, int b, int c) {
    vector <int> ans(3);
    ans[0] = a, ans[1] = b, ans[2] = c;
    return ans;
}


vector< int > tree;

void update(int v) {

    if(v == 0)
        return;
    tree[v] = tree[2 * v] + tree[2 * v + 1];
    update(v/ 2);

}

int get_sum(int v, int l, int r, int vl, int vr) {

    if(r <= vl || vr <= l)
        return 0;
    if(vl <= l && r <= vr)
        return tree[v];
    int m = (l + r) / 2;
    return get_sum(v * 2, l, m, vl, vr) + get_sum(v * 2 + 1, m, r, vl, vr);


}

int main() {

    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector<int> a(n + 2);
    vector<int> b(m + 2);
    vector<bool> used(n + 2, 0);
    vector< vector<int> > next(n + 2, vector<int> (0));
    set < pair<int, int> > por;

    for (int i = 0; i < m; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    for (int i = 0; i < n; i++) {
        por.insert(make_pair(i, b[i]));
    }

    vector<int> rasm;

    for (int i = 0; i < m; i++) {
        if(!used[a[i]]) {
            while(1) {
                pair<int, int> x = *por.begin();
                por.erase(x);
                used[x.s] = 1;
                if(x.s == a[i])
                    break;
                rasm.push_back(x.s);
            }
        }
        rasm.push_back(a[i]);
    }


    for (int i = rasm.size() - 1; i >= 0; i--) {
        next[rasm[i]].push_back(i);
    }
    int N = 1;
    while(N <= rasm.size())
        N *= 2;
    tree = vector<int> (2 * N, 0);
    vector<int> ans(rasm.size(), n - 1);

    used.assign(n + 2, 0);
    for (int i = 0; i < rasm.size(); i++) {
        if(used[rasm[i]])
            continue;
        used[rasm[i]] = 1;
        tree[N + i] = 1;
        update((N + i) / 2);
    }

    for (int i = 0; i < rasm.size(); i++) {
        next[rasm[i]].pop_back();
        if(next[rasm[i]].size() == 0)
            continue;
        int nxt = next[rasm[i]][next[rasm[i]].size() - 1];
        tree[N + i] = 0;
        update((N + i) / 2);
        tree[N + nxt] = 1;
        update((N + nxt) / 2);
        ans[i] = get_sum(1, 0, N, i, nxt);
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i] + 1 << " ";
    }
}


/*
4 5
4 1 2 4 4
4 3 2 1
*/
