#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;


int max_log = 70;
ll mod = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    ll n, m, k;
    cin >> n >> m >> k;
    vector < vector < ll > > dp(n + 1, vector < ll > (k + 1, 0));
    for (int i = 0; i <= k; i++) {
        dp[n][i] = 1;
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j <= k; j++) {
            for (int x = 0; x <= k; x++) {
                if((x & j) != j)
                    continue;
                dp[i][j] = (dp[i][j] + dp[i + 1][x]) % mod;
            }
        }
    }
    cout << dp[0][0] << endl;
}
