#include <iostream>
#include <vector>

using namespace std;
typedef long long ll;


int maxlog = 3;
ll mod = 1e9 + 7;


int main() {

    ios_base::sync_with_stdio(0);
    int n, m, k;
    cin >> n >> m >> k;
    vector< vector<ll> > dp(n + 1, vector<ll> (n + 1, 0));
    vector< vector<ll> > dp2(k + 2, vector<ll> (n + 1, 0));
    vector<int> g(n, n);

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a] = min(g[a], b);
    }
    dp[n][0] = 1;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 1; j <= n; j++) {
            int r = g[i];
            for (int z = i + 1; z <= r; z++) {
                dp[i][j] = (dp[i][j] + dp[z][j - 1]) % mod;
                r = min(r, g[z]);
            }
        }
    }

    for (int i = 0; i <= k; i++)
        dp2[i][1] = 1;

    for (int j = 2; j <= n; j++) {
        for (int i = k; i >= 0; i--) {
            for (int z = 0; z <= k; z++) {
                if ((i & z) != z || i == z)
                    continue;
                dp2[i][j] = (dp2[i][j] + dp2[z][j - 1]) % mod;
            }
        }
    }
    vector<ll> sum(n + 1, 0);
    for(int i = 1; i <= n; i++) {
        for (int j = 0; j <= k; j++) {
            sum[i] = (sum[i] + dp2[j][i]) % mod;
        }
    }

    ll ans = 0;
    for (int i = 1; i <= n; i++) {
        ans = (ans + sum[i] * dp[0][i]) % mod;
    }
    cout << ans << endl;
}
