#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#define f first
#define s second

using namespace std;

vector<vector<int>> a;
vector<vector<int>> par;
map<vector<int>, vector<int>> have;
vector<int> rasm;

bool find_ans(int n, int k, int i) {

    if(i == k) {
        if(have[rasm].size() == 0)
            return true;

        vector<int> obr;
        for (int j = 0; j < k; j++) {
            obr.push_back(1 - rasm[j]);
        }
        if(have[obr].size() != have[rasm].size())
            return false;
        while(have[rasm].size() > 0) {
            par.push_back({have[obr].back(), have[rasm].back()});
            have[rasm].pop_back();
            have[obr].pop_back();
        }
        return true;
    }
    for (int j = 0; j < 2; j++) {
        rasm.push_back(j);
        if(!find_ans(n, k, i + 1))
            return false;
        rasm.pop_back();
    }
    return true;
}

int main() {

    ios_base::sync_with_stdio(0);
    int n, k;
    cin >> n >> k;
    a = vector<vector<int>> (n, vector<int> (k, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < k; i++) {
        vector<pair<int, int>> for_sort;
        for (int j = 0; j < n; j++) {
            for_sort.push_back({a[j][i], j});
        }
        sort(for_sort.begin(), for_sort.end());
        for (int j = 0; j < n / 2; j++) {
            g[for_sort[j].s].push_back(0);
        }
        for (int j = n / 2; j < n; j++) {
            g[for_sort[j].s].push_back(1);
        }
    }
    for (int i = 0; i < n; i++) {
        have[g[i]].push_back(i);
    }
    bool ans = find_ans(n, k, 0);
    if(!ans) {
        cout << "NO";
        return 0;
    }
    cout << "YES" << endl;
    for(int i = 0; i < n / 2; i++) {
        cout << par[i][0] + 1 << " " << par[i][1] + 1 << endl;
    }


}
